#
#  pygGraf.py
#
import pygame
from pygSprites import sprites, S_WIDTH, S_HEIGHT, C_WIDTH, C_HEIGHT

K_UP   = 273
K_DOWN = 274
K_RIGHT= 275
K_LEFT = 276
K_F10  = 291

def setSpecial() :
    global screen, sprites
    screen = pygame.display.set_mode(( S_WIDTH, S_HEIGHT))

def setNormal() :
    pygame.display.quit()

def readLookAhead() :
    "Check pygame event queue for keys OR closing window"
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            return pygame.K_F10          # to force a quit
        elif event.type == pygame.KEYDOWN:
            ch = event.key
            if ch < 256 : ch = chr(ch)
            return ch
    return None

def writeBoard() :
    'write entire board to the screen'
    from board import board
    pygame.draw.rect(screen, (128,128,128), (0,0,S_WIDTH,S_HEIGHT), 0)
    for row in range(len(board)) :
        writeScreen(row,0,board[row])

def writeScreen(row,col,chars) :
    'write chars to screen at row,col'
    x = col * C_WIDTH
    y = row * C_HEIGHT
    for ch in chars :
        sprite = sprites.get(ch)
        if sprite : screen.blit(sprite,(x,y))
        x += C_WIDTH
    pygame.display.flip()

