#!/usr/bin/env python
#
#   p y g L o d e . p y
#
import random, time
import pygGraf as grf
from   board   import getSpot, setSpot

class Player :
    def setDirection (self, ch) : pass

    def move (self) :
        global inPlay, you, players
        spot = getSpot(self.row,self.col)
        lspot = getSpot(self.row,self.col-1)
        rspot = getSpot(self.row,self.col+1)
  
        horz,vert = self.dir
        grf.writeScreen(self.row,self.col,spot)
        if   spot == '_' : self.col += horz  # by left/right arself.row
        elif spot == '|' :
            self.row -= vert  # by up/down arrow
            self.col += horz  # ok to jump aside
        elif spot == ' ' : self.row += 1     # always fall in air
        # Ok to walk horizontally past a ladder or obstacle
        if   lspot == '_' and horz == -1 : self.col -= 1
        elif rspot == '_' and horz ==  1 : self.col += 1
        grf.writeScreen(self.row,self.col,self.face)
        if self.row > 23 :
            if self.face == '^' : inPlay = 0
            else : players.remove(self)

class You(Player) :
    def __init__ (self, Row=1, Col=10, Face='^') :
        self.row = Row; self.col = Col; self.face=Face
        self.dir = (0,0); self.score=0

    def setDirection (self, ch) :
        global inPlay
        here = getSpot(self.row,self.col)
        if here == '*' :
            self.score += 10
            setSpot(self.row,self.col,"_")
            grf.writeScreen(self.row,self.col,"_")   # update the screen

        if ch == grf.K_F10   : inPlay = 0
        if ch == grf.K_UP    : self.dir=( 0, 1)
        if ch == grf.K_DOWN  : self.dir=( 0,-1)
        if ch == grf.K_RIGHT : self.dir=( 1, 0)
        if ch == grf.K_LEFT  : self.dir=(-1, 0)
        if ch == 'a' : burn(self.row, self.col-1)
        if ch == 's' : burn(self.row, self.col+1)

class Robot(Player) :
    def __init__ (self, Row=1, Col=12, Face='&') :
        self.row = Row; self.col = Col; self.face=Face
        self.hisLadder = 0
        self.dir = (0,0)

    def move (self) :
        global clock
        if clock%2 == 0 : Player.move(self)

    def setDirection (self, ch) :
        global inPlay, you
        # did we tag him?
        if you.row == self.row and you.col == self.col : inPlay=0
        # same level. run toward you
        if self.row == you.row :
            if self.col > you.col : self.dir=(-1,0) # left
            if self.col < you.col : self.dir=( 1,0) # right
        else :
            me = getSpot(self.row,self.col)  # where am I
            if me == "|" : # on a ladder
                if self.row > you.row : self.dir=(0, 1) # up
                if self.row < you.row : self.dir=(0,-1) # down
    
def burn (row,col) :
    "Burn or repair a hole in the catwalk at row,col"
    now = getSpot(row,col)     # get the board
    if now == " " : nxt = "_"  # repair hole
    else          : nxt = " "  # or burn one
    setSpot(row,col,nxt)       # set the board
    grf.writeScreen(row,col,nxt)   # update the screen

def main ():
    try :
        grf.setSpecial()
        playGame()
    finally : grf.setNormal()

def playGame() :
    global clock, inPlay, you, players
    you = You()
    grf.writeBoard ()
    players = [you]
    clock = 0
    inPlay = 1
    while inPlay :
        clock += 1
        if clock > 40 and len(players) < 3 :
            players.append(Robot(Col=int(random.random()*40+5)))
        time.sleep(.15)
        keys = grf.readLookAhead()
        for player in players :
            player.setDirection(keys)
            player.move()
        grf.writeScreen (20,0,'Score: %d' % you.score)
    grf.writeScreen (20,0,'')

if __name__ == "__main__" : main()
